searchData={"items":[{"type":"module","title":"GoogleApi.FirebaseRules.V1","doc":"API client metadata for GoogleApi.FirebaseRules.V1.","ref":"GoogleApi.FirebaseRules.V1.html"},{"type":"function","title":"GoogleApi.FirebaseRules.V1.discovery_revision/0","doc":"","ref":"GoogleApi.FirebaseRules.V1.html#discovery_revision/0"},{"type":"module","title":"GoogleApi.FirebaseRules.V1.Api.Projects","doc":"API calls for all endpoints tagged `Projects`.","ref":"GoogleApi.FirebaseRules.V1.Api.Projects.html"},{"type":"function","title":"GoogleApi.FirebaseRules.V1.Api.Projects.firebaserules_projects_releases_create/4","doc":"Create a `Release`. Release names should reflect the developer's deployment practices. For example, the release name may include the environment name, application name, application version, or any other name meaningful to the developer. Once a `Release` refers to a `Ruleset`, the rules can be enforced by Firebase Rules-enabled services. More than one `Release` may be 'live' concurrently. Consider the following three `Release` names for `projects/foo` and the `Ruleset` to which they refer. Release Name -> Ruleset Name * projects/foo/releases/prod -> projects/foo/rulesets/uuid123 * projects/foo/releases/prod/beta -> projects/foo/rulesets/uuid123 * projects/foo/releases/prod/v23 -> projects/foo/rulesets/uuid456 The relationships reflect a `Ruleset` rollout in progress. The `prod` and `prod/beta` releases refer to the same `Ruleset`. However, `prod/v23` refers to a new `Ruleset`. The `Ruleset` reference for a `Release` may be updated using the UpdateRelease method.","ref":"GoogleApi.FirebaseRules.V1.Api.Projects.html#firebaserules_projects_releases_create/4"},{"type":"function","title":"Parameters - GoogleApi.FirebaseRules.V1.Api.Projects.firebaserules_projects_releases_create/4","doc":"*   `connection` (*type:* `GoogleApi.FirebaseRules.V1.Connection.t`) - Connection to server\n*   `name` (*type:* `String.t`) - Required. Resource name for the project which owns this `Release`. Format: `projects/{project_id}`\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.FirebaseRules.V1.Model.Release.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.FirebaseRules.V1.Api.Projects.html#firebaserules_projects_releases_create/4-parameters"},{"type":"function","title":"Returns - GoogleApi.FirebaseRules.V1.Api.Projects.firebaserules_projects_releases_create/4","doc":"*   `{:ok, %GoogleApi.FirebaseRules.V1.Model.Release{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.FirebaseRules.V1.Api.Projects.html#firebaserules_projects_releases_create/4-returns"},{"type":"function","title":"GoogleApi.FirebaseRules.V1.Api.Projects.firebaserules_projects_releases_delete/4","doc":"Delete a `Release` by resource name.","ref":"GoogleApi.FirebaseRules.V1.Api.Projects.html#firebaserules_projects_releases_delete/4"},{"type":"function","title":"Parameters - GoogleApi.FirebaseRules.V1.Api.Projects.firebaserules_projects_releases_delete/4","doc":"*   `connection` (*type:* `GoogleApi.FirebaseRules.V1.Connection.t`) - Connection to server\n*   `name` (*type:* `String.t`) - Required. Resource name for the `Release` to delete. Format: `projects/{project_id}/releases/{release_id}`\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.FirebaseRules.V1.Api.Projects.html#firebaserules_projects_releases_delete/4-parameters"},{"type":"function","title":"Returns - GoogleApi.FirebaseRules.V1.Api.Projects.firebaserules_projects_releases_delete/4","doc":"*   `{:ok, %GoogleApi.FirebaseRules.V1.Model.Empty{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.FirebaseRules.V1.Api.Projects.html#firebaserules_projects_releases_delete/4-returns"},{"type":"function","title":"GoogleApi.FirebaseRules.V1.Api.Projects.firebaserules_projects_releases_get/4","doc":"Get a `Release` by name.","ref":"GoogleApi.FirebaseRules.V1.Api.Projects.html#firebaserules_projects_releases_get/4"},{"type":"function","title":"Parameters - GoogleApi.FirebaseRules.V1.Api.Projects.firebaserules_projects_releases_get/4","doc":"*   `connection` (*type:* `GoogleApi.FirebaseRules.V1.Connection.t`) - Connection to server\n*   `name` (*type:* `String.t`) - Required. Resource name of the `Release`. Format: `projects/{project_id}/releases/{release_id}`\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.FirebaseRules.V1.Api.Projects.html#firebaserules_projects_releases_get/4-parameters"},{"type":"function","title":"Returns - GoogleApi.FirebaseRules.V1.Api.Projects.firebaserules_projects_releases_get/4","doc":"*   `{:ok, %GoogleApi.FirebaseRules.V1.Model.Release{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.FirebaseRules.V1.Api.Projects.html#firebaserules_projects_releases_get/4-returns"},{"type":"function","title":"GoogleApi.FirebaseRules.V1.Api.Projects.firebaserules_projects_releases_get_executable/4","doc":"Get the `Release` executable to use when enforcing rules.","ref":"GoogleApi.FirebaseRules.V1.Api.Projects.html#firebaserules_projects_releases_get_executable/4"},{"type":"function","title":"Parameters - GoogleApi.FirebaseRules.V1.Api.Projects.firebaserules_projects_releases_get_executable/4","doc":"*   `connection` (*type:* `GoogleApi.FirebaseRules.V1.Connection.t`) - Connection to server\n*   `name` (*type:* `String.t`) - Required. Resource name of the `Release`. Format: `projects/{project_id}/releases/{release_id}`\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:executableVersion` (*type:* `String.t`) - Optional. The requested runtime executable version. Defaults to FIREBASE_RULES_EXECUTABLE_V1.\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.FirebaseRules.V1.Api.Projects.html#firebaserules_projects_releases_get_executable/4-parameters"},{"type":"function","title":"Returns - GoogleApi.FirebaseRules.V1.Api.Projects.firebaserules_projects_releases_get_executable/4","doc":"*   `{:ok, %GoogleApi.FirebaseRules.V1.Model.GetReleaseExecutableResponse{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.FirebaseRules.V1.Api.Projects.html#firebaserules_projects_releases_get_executable/4-returns"},{"type":"function","title":"GoogleApi.FirebaseRules.V1.Api.Projects.firebaserules_projects_releases_list/4","doc":"List the `Release` values for a project. This list may optionally be filtered by `Release` name, `Ruleset` name, `TestSuite` name, or any combination thereof.","ref":"GoogleApi.FirebaseRules.V1.Api.Projects.html#firebaserules_projects_releases_list/4"},{"type":"function","title":"Parameters - GoogleApi.FirebaseRules.V1.Api.Projects.firebaserules_projects_releases_list/4","doc":"*   `connection` (*type:* `GoogleApi.FirebaseRules.V1.Connection.t`) - Connection to server\n*   `name` (*type:* `String.t`) - Required. Resource name for the project. Format: `projects/{project_id}`\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:filter` (*type:* `String.t`) - Optional. `Release` filter. The list method supports filters with restrictions on the `Release.name`, and `Release.ruleset_name`. Example 1: A filter of 'name=prod*' might return `Release`s with names within 'projects/foo' prefixed with 'prod': Name -> Ruleset Name: * projects/foo/releases/prod -> projects/foo/rulesets/uuid1234 * projects/foo/releases/prod/v1 -> projects/foo/rulesets/uuid1234 * projects/foo/releases/prod/v2 -> projects/foo/rulesets/uuid8888 Example 2: A filter of `name=prod* ruleset_name=uuid1234` would return only `Release` instances for 'projects/foo' with names prefixed with 'prod' referring to the same `Ruleset` name of 'uuid1234': Name -> Ruleset Name: * projects/foo/releases/prod -> projects/foo/rulesets/1234 * projects/foo/releases/prod/v1 -> projects/foo/rulesets/1234 In the examples, the filter parameters refer to the search filters are relative to the project. Fully qualified prefixed may also be used.\n    *   `:pageSize` (*type:* `integer()`) - Optional. Page size to load. Maximum of 100. Defaults to 10. Note: `page_size` is just a hint and the service may choose to load fewer than `page_size` results due to the size of the output. To traverse all of the releases, the caller should iterate until the `page_token` on the response is empty.\n    *   `:pageToken` (*type:* `String.t`) - Optional. Next page token for the next batch of `Release` instances.\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.FirebaseRules.V1.Api.Projects.html#firebaserules_projects_releases_list/4-parameters"},{"type":"function","title":"Returns - GoogleApi.FirebaseRules.V1.Api.Projects.firebaserules_projects_releases_list/4","doc":"*   `{:ok, %GoogleApi.FirebaseRules.V1.Model.ListReleasesResponse{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.FirebaseRules.V1.Api.Projects.html#firebaserules_projects_releases_list/4-returns"},{"type":"function","title":"GoogleApi.FirebaseRules.V1.Api.Projects.firebaserules_projects_releases_patch/4","doc":"Update a `Release` via PATCH. Only updates to `ruleset_name` will be honored. `Release` rename is not supported. To create a `Release` use the CreateRelease method.","ref":"GoogleApi.FirebaseRules.V1.Api.Projects.html#firebaserules_projects_releases_patch/4"},{"type":"function","title":"Parameters - GoogleApi.FirebaseRules.V1.Api.Projects.firebaserules_projects_releases_patch/4","doc":"*   `connection` (*type:* `GoogleApi.FirebaseRules.V1.Connection.t`) - Connection to server\n*   `name` (*type:* `String.t`) - Required. Resource name for the project which owns this `Release`. Format: `projects/{project_id}`\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.FirebaseRules.V1.Model.UpdateReleaseRequest.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.FirebaseRules.V1.Api.Projects.html#firebaserules_projects_releases_patch/4-parameters"},{"type":"function","title":"Returns - GoogleApi.FirebaseRules.V1.Api.Projects.firebaserules_projects_releases_patch/4","doc":"*   `{:ok, %GoogleApi.FirebaseRules.V1.Model.Release{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.FirebaseRules.V1.Api.Projects.html#firebaserules_projects_releases_patch/4-returns"},{"type":"function","title":"GoogleApi.FirebaseRules.V1.Api.Projects.firebaserules_projects_rulesets_create/4","doc":"Create a `Ruleset` from `Source`. The `Ruleset` is given a unique generated name which is returned to the caller. `Source` containing syntactic or semantics errors will result in an error response indicating the first error encountered. For a detailed view of `Source` issues, use TestRuleset.","ref":"GoogleApi.FirebaseRules.V1.Api.Projects.html#firebaserules_projects_rulesets_create/4"},{"type":"function","title":"Parameters - GoogleApi.FirebaseRules.V1.Api.Projects.firebaserules_projects_rulesets_create/4","doc":"*   `connection` (*type:* `GoogleApi.FirebaseRules.V1.Connection.t`) - Connection to server\n*   `name` (*type:* `String.t`) - Required. Resource name for Project which owns this `Ruleset`. Format: `projects/{project_id}`\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.FirebaseRules.V1.Model.Ruleset.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.FirebaseRules.V1.Api.Projects.html#firebaserules_projects_rulesets_create/4-parameters"},{"type":"function","title":"Returns - GoogleApi.FirebaseRules.V1.Api.Projects.firebaserules_projects_rulesets_create/4","doc":"*   `{:ok, %GoogleApi.FirebaseRules.V1.Model.Ruleset{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.FirebaseRules.V1.Api.Projects.html#firebaserules_projects_rulesets_create/4-returns"},{"type":"function","title":"GoogleApi.FirebaseRules.V1.Api.Projects.firebaserules_projects_rulesets_delete/4","doc":"Delete a `Ruleset` by resource name. If the `Ruleset` is referenced by a `Release` the operation will fail.","ref":"GoogleApi.FirebaseRules.V1.Api.Projects.html#firebaserules_projects_rulesets_delete/4"},{"type":"function","title":"Parameters - GoogleApi.FirebaseRules.V1.Api.Projects.firebaserules_projects_rulesets_delete/4","doc":"*   `connection` (*type:* `GoogleApi.FirebaseRules.V1.Connection.t`) - Connection to server\n*   `name` (*type:* `String.t`) - Required. Resource name for the ruleset to delete. Format: `projects/{project_id}/rulesets/{ruleset_id}`\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.FirebaseRules.V1.Api.Projects.html#firebaserules_projects_rulesets_delete/4-parameters"},{"type":"function","title":"Returns - GoogleApi.FirebaseRules.V1.Api.Projects.firebaserules_projects_rulesets_delete/4","doc":"*   `{:ok, %GoogleApi.FirebaseRules.V1.Model.Empty{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.FirebaseRules.V1.Api.Projects.html#firebaserules_projects_rulesets_delete/4-returns"},{"type":"function","title":"GoogleApi.FirebaseRules.V1.Api.Projects.firebaserules_projects_rulesets_get/4","doc":"Get a `Ruleset` by name including the full `Source` contents.","ref":"GoogleApi.FirebaseRules.V1.Api.Projects.html#firebaserules_projects_rulesets_get/4"},{"type":"function","title":"Parameters - GoogleApi.FirebaseRules.V1.Api.Projects.firebaserules_projects_rulesets_get/4","doc":"*   `connection` (*type:* `GoogleApi.FirebaseRules.V1.Connection.t`) - Connection to server\n*   `name` (*type:* `String.t`) - Required. Resource name for the ruleset to get. Format: `projects/{project_id}/rulesets/{ruleset_id}`\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.FirebaseRules.V1.Api.Projects.html#firebaserules_projects_rulesets_get/4-parameters"},{"type":"function","title":"Returns - GoogleApi.FirebaseRules.V1.Api.Projects.firebaserules_projects_rulesets_get/4","doc":"*   `{:ok, %GoogleApi.FirebaseRules.V1.Model.Ruleset{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.FirebaseRules.V1.Api.Projects.html#firebaserules_projects_rulesets_get/4-returns"},{"type":"function","title":"GoogleApi.FirebaseRules.V1.Api.Projects.firebaserules_projects_rulesets_list/4","doc":"List `Ruleset` metadata only and optionally filter the results by `Ruleset` name. The full `Source` contents of a `Ruleset` may be retrieved with GetRuleset.","ref":"GoogleApi.FirebaseRules.V1.Api.Projects.html#firebaserules_projects_rulesets_list/4"},{"type":"function","title":"Parameters - GoogleApi.FirebaseRules.V1.Api.Projects.firebaserules_projects_rulesets_list/4","doc":"*   `connection` (*type:* `GoogleApi.FirebaseRules.V1.Connection.t`) - Connection to server\n*   `name` (*type:* `String.t`) - Required. Resource name for the project. Format: `projects/{project_id}`\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:filter` (*type:* `String.t`) - Optional. `Ruleset` filter. The list method supports filters with restrictions on `Ruleset.name`. Filters on `Ruleset.create_time` should use the `date` function which parses strings that conform to the RFC 3339 date/time specifications. Example: `create_time > date(\"2017-01-01T00:00:00Z\") AND name=UUID-*`\n    *   `:pageSize` (*type:* `integer()`) - Optional. Page size to load. Maximum of 100. Defaults to 10. Note: `page_size` is just a hint and the service may choose to load less than `page_size` due to the size of the output. To traverse all of the releases, caller should iterate until the `page_token` is empty.\n    *   `:pageToken` (*type:* `String.t`) - Optional. Next page token for loading the next batch of `Ruleset` instances.\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.FirebaseRules.V1.Api.Projects.html#firebaserules_projects_rulesets_list/4-parameters"},{"type":"function","title":"Returns - GoogleApi.FirebaseRules.V1.Api.Projects.firebaserules_projects_rulesets_list/4","doc":"*   `{:ok, %GoogleApi.FirebaseRules.V1.Model.ListRulesetsResponse{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.FirebaseRules.V1.Api.Projects.html#firebaserules_projects_rulesets_list/4-returns"},{"type":"function","title":"GoogleApi.FirebaseRules.V1.Api.Projects.firebaserules_projects_test/4","doc":"Test `Source` for syntactic and semantic correctness. Issues present, if any, will be returned to the caller with a description, severity, and source location. The test method may be executed with `Source` or a `Ruleset` name. Passing `Source` is useful for unit testing new rules. Passing a `Ruleset` name is useful for regression testing an existing rule. The following is an example of `Source` that permits users to upload images to a bucket bearing their user id and matching the correct metadata: _*Example*_ // Users are allowed to subscribe and unsubscribe to the blog. service firebase.storage { match /users/{userId}/images/{imageName} { allow write: if userId == request.auth.uid && (imageName.matches('*.png$') || imageName.matches('*.jpg$')) && resource.mimeType.matches('^image/') } }","ref":"GoogleApi.FirebaseRules.V1.Api.Projects.html#firebaserules_projects_test/4"},{"type":"function","title":"Parameters - GoogleApi.FirebaseRules.V1.Api.Projects.firebaserules_projects_test/4","doc":"*   `connection` (*type:* `GoogleApi.FirebaseRules.V1.Connection.t`) - Connection to server\n*   `name` (*type:* `String.t`) - Required. Tests may either provide `source` or a `Ruleset` resource name. For tests against `source`, the resource name must refer to the project: Format: `projects/{project_id}` For tests against a `Ruleset`, this must be the `Ruleset` resource name: Format: `projects/{project_id}/rulesets/{ruleset_id}`\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.FirebaseRules.V1.Model.TestRulesetRequest.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.FirebaseRules.V1.Api.Projects.html#firebaserules_projects_test/4-parameters"},{"type":"function","title":"Returns - GoogleApi.FirebaseRules.V1.Api.Projects.firebaserules_projects_test/4","doc":"*   `{:ok, %GoogleApi.FirebaseRules.V1.Model.TestRulesetResponse{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.FirebaseRules.V1.Api.Projects.html#firebaserules_projects_test/4-returns"},{"type":"module","title":"GoogleApi.FirebaseRules.V1.Connection","doc":"Handle Tesla connections for GoogleApi.FirebaseRules.V1.","ref":"GoogleApi.FirebaseRules.V1.Connection.html"},{"type":"function","title":"GoogleApi.FirebaseRules.V1.Connection.delete/3","doc":"Perform a DELETE request.\n\nSee `request/1` or `request/2` for options definition.\n\n    delete(\"/users\")\n    delete(\"/users\", query: [scope: \"admin\"])\n    delete(client, \"/users\")\n    delete(client, \"/users\", query: [scope: \"admin\"])\n    delete(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.FirebaseRules.V1.Connection.html#delete/3"},{"type":"function","title":"GoogleApi.FirebaseRules.V1.Connection.delete!/3","doc":"Perform a DELETE request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    delete!(\"/users\")\n    delete!(\"/users\", query: [scope: \"admin\"])\n    delete!(client, \"/users\")\n    delete!(client, \"/users\", query: [scope: \"admin\"])\n    delete!(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.FirebaseRules.V1.Connection.html#delete!/3"},{"type":"function","title":"GoogleApi.FirebaseRules.V1.Connection.execute/2","doc":"Execute a request on this connection","ref":"GoogleApi.FirebaseRules.V1.Connection.html#execute/2"},{"type":"function","title":"Returns - GoogleApi.FirebaseRules.V1.Connection.execute/2","doc":"*   `{:ok, Tesla.Env.t}` - If the call was successful\n*   `{:error, reason}` - If the call failed","ref":"GoogleApi.FirebaseRules.V1.Connection.html#execute/2-returns"},{"type":"function","title":"GoogleApi.FirebaseRules.V1.Connection.get/3","doc":"Perform a GET request.\n\nSee `request/1` or `request/2` for options definition.\n\n    get(\"/users\")\n    get(\"/users\", query: [scope: \"admin\"])\n    get(client, \"/users\")\n    get(client, \"/users\", query: [scope: \"admin\"])\n    get(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.FirebaseRules.V1.Connection.html#get/3"},{"type":"function","title":"GoogleApi.FirebaseRules.V1.Connection.get!/3","doc":"Perform a GET request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    get!(\"/users\")\n    get!(\"/users\", query: [scope: \"admin\"])\n    get!(client, \"/users\")\n    get!(client, \"/users\", query: [scope: \"admin\"])\n    get!(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.FirebaseRules.V1.Connection.html#get!/3"},{"type":"function","title":"GoogleApi.FirebaseRules.V1.Connection.head/3","doc":"Perform a HEAD request.\n\nSee `request/1` or `request/2` for options definition.\n\n    head(\"/users\")\n    head(\"/users\", query: [scope: \"admin\"])\n    head(client, \"/users\")\n    head(client, \"/users\", query: [scope: \"admin\"])\n    head(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.FirebaseRules.V1.Connection.html#head/3"},{"type":"function","title":"GoogleApi.FirebaseRules.V1.Connection.head!/3","doc":"Perform a HEAD request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    head!(\"/users\")\n    head!(\"/users\", query: [scope: \"admin\"])\n    head!(client, \"/users\")\n    head!(client, \"/users\", query: [scope: \"admin\"])\n    head!(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.FirebaseRules.V1.Connection.html#head!/3"},{"type":"function","title":"GoogleApi.FirebaseRules.V1.Connection.new/0","doc":"Configure an authless client connection","ref":"GoogleApi.FirebaseRules.V1.Connection.html#new/0"},{"type":"function","title":"Returns - GoogleApi.FirebaseRules.V1.Connection.new/0","doc":"*   `Tesla.Env.client`","ref":"GoogleApi.FirebaseRules.V1.Connection.html#new/0-returns"},{"type":"function","title":"GoogleApi.FirebaseRules.V1.Connection.new/1","doc":"Configure a client connection using a function which yields a Bearer token.","ref":"GoogleApi.FirebaseRules.V1.Connection.html#new/1"},{"type":"function","title":"Parameters - GoogleApi.FirebaseRules.V1.Connection.new/1","doc":"*   `token_fetcher` (*type:* `list(String.t()) -> String.t()`) - Callback\n    which provides an OAuth2 token given a list of scopes","ref":"GoogleApi.FirebaseRules.V1.Connection.html#new/1-parameters"},{"type":"function","title":"Returns - GoogleApi.FirebaseRules.V1.Connection.new/1","doc":"*   `Tesla.Env.client`","ref":"GoogleApi.FirebaseRules.V1.Connection.html#new/1-returns"},{"type":"function","title":"GoogleApi.FirebaseRules.V1.Connection.options/3","doc":"Perform a OPTIONS request.\n\nSee `request/1` or `request/2` for options definition.\n\n    options(\"/users\")\n    options(\"/users\", query: [scope: \"admin\"])\n    options(client, \"/users\")\n    options(client, \"/users\", query: [scope: \"admin\"])\n    options(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.FirebaseRules.V1.Connection.html#options/3"},{"type":"function","title":"GoogleApi.FirebaseRules.V1.Connection.options!/3","doc":"Perform a OPTIONS request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    options!(\"/users\")\n    options!(\"/users\", query: [scope: \"admin\"])\n    options!(client, \"/users\")\n    options!(client, \"/users\", query: [scope: \"admin\"])\n    options!(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.FirebaseRules.V1.Connection.html#options!/3"},{"type":"function","title":"GoogleApi.FirebaseRules.V1.Connection.patch/4","doc":"Perform a PATCH request.\n\nSee `request/1` or `request/2` for options definition.\n\n    patch(\"/users\", %{name: \"Jon\"})\n    patch(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    patch(client, \"/users\", %{name: \"Jon\"})\n    patch(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"GoogleApi.FirebaseRules.V1.Connection.html#patch/4"},{"type":"function","title":"GoogleApi.FirebaseRules.V1.Connection.patch!/4","doc":"Perform a PATCH request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    patch!(\"/users\", %{name: \"Jon\"})\n    patch!(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    patch!(client, \"/users\", %{name: \"Jon\"})\n    patch!(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"GoogleApi.FirebaseRules.V1.Connection.html#patch!/4"},{"type":"function","title":"GoogleApi.FirebaseRules.V1.Connection.post/4","doc":"Perform a POST request.\n\nSee `request/1` or `request/2` for options definition.\n\n    post(\"/users\", %{name: \"Jon\"})\n    post(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    post(client, \"/users\", %{name: \"Jon\"})\n    post(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"GoogleApi.FirebaseRules.V1.Connection.html#post/4"},{"type":"function","title":"GoogleApi.FirebaseRules.V1.Connection.post!/4","doc":"Perform a POST request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    post!(\"/users\", %{name: \"Jon\"})\n    post!(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    post!(client, \"/users\", %{name: \"Jon\"})\n    post!(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"GoogleApi.FirebaseRules.V1.Connection.html#post!/4"},{"type":"function","title":"GoogleApi.FirebaseRules.V1.Connection.put/4","doc":"Perform a PUT request.\n\nSee `request/1` or `request/2` for options definition.\n\n    put(\"/users\", %{name: \"Jon\"})\n    put(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    put(client, \"/users\", %{name: \"Jon\"})\n    put(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"GoogleApi.FirebaseRules.V1.Connection.html#put/4"},{"type":"function","title":"GoogleApi.FirebaseRules.V1.Connection.put!/4","doc":"Perform a PUT request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    put!(\"/users\", %{name: \"Jon\"})\n    put!(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    put!(client, \"/users\", %{name: \"Jon\"})\n    put!(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"GoogleApi.FirebaseRules.V1.Connection.html#put!/4"},{"type":"function","title":"GoogleApi.FirebaseRules.V1.Connection.request/2","doc":"Perform a request.","ref":"GoogleApi.FirebaseRules.V1.Connection.html#request/2"},{"type":"function","title":"Options - GoogleApi.FirebaseRules.V1.Connection.request/2","doc":"- `:method` - the request method, one of [`:head`, `:get`, `:delete`, `:trace`, `:options`, `:post`, `:put`, `:patch`]\n- `:url` - either full url e.g. \"http://example.com/some/path\" or just \"/some/path\" if using `Tesla.Middleware.BaseUrl`\n- `:query` - a keyword list of query params, e.g. `[page: 1, per_page: 100]`\n- `:headers` - a keyword list of headers, e.g. `[{\"content-type\", \"text/plain\"}]`\n- `:body` - depends on used middleware:\n    - by default it can be a binary\n    - if using e.g. JSON encoding middleware it can be a nested map\n    - if adapter supports it it can be a Stream with any of the above\n- `:opts` - custom, per-request middleware or adapter options","ref":"GoogleApi.FirebaseRules.V1.Connection.html#request/2-options"},{"type":"function","title":"Examples - GoogleApi.FirebaseRules.V1.Connection.request/2","doc":"ExampleApi.request(method: :get, url: \"/users/path\")\n\n    # use shortcut methods\n    ExampleApi.get(\"/users/1\")\n    ExampleApi.post(client, \"/users\", %{name: \"Jon\"})","ref":"GoogleApi.FirebaseRules.V1.Connection.html#request/2-examples"},{"type":"function","title":"GoogleApi.FirebaseRules.V1.Connection.request!/2","doc":"Perform request and raise in case of error.\n\nThis is similar to `request/2` behaviour from Tesla 0.x\n\nSee `request/2` for list of available options.","ref":"GoogleApi.FirebaseRules.V1.Connection.html#request!/2"},{"type":"function","title":"GoogleApi.FirebaseRules.V1.Connection.trace/3","doc":"Perform a TRACE request.\n\nSee `request/1` or `request/2` for options definition.\n\n    trace(\"/users\")\n    trace(\"/users\", query: [scope: \"admin\"])\n    trace(client, \"/users\")\n    trace(client, \"/users\", query: [scope: \"admin\"])\n    trace(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.FirebaseRules.V1.Connection.html#trace/3"},{"type":"function","title":"GoogleApi.FirebaseRules.V1.Connection.trace!/3","doc":"Perform a TRACE request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    trace!(\"/users\")\n    trace!(\"/users\", query: [scope: \"admin\"])\n    trace!(client, \"/users\")\n    trace!(client, \"/users\", query: [scope: \"admin\"])\n    trace!(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.FirebaseRules.V1.Connection.html#trace!/3"},{"type":"type","title":"GoogleApi.FirebaseRules.V1.Connection.option/0","doc":"Options that may be passed to a request function. See `request/2` for detailed descriptions.","ref":"GoogleApi.FirebaseRules.V1.Connection.html#t:option/0"},{"type":"type","title":"GoogleApi.FirebaseRules.V1.Connection.t/0","doc":"","ref":"GoogleApi.FirebaseRules.V1.Connection.html#t:t/0"},{"type":"module","title":"GoogleApi.FirebaseRules.V1.Model.Arg","doc":"Arg matchers for the mock function.","ref":"GoogleApi.FirebaseRules.V1.Model.Arg.html"},{"type":"module","title":"Attributes - GoogleApi.FirebaseRules.V1.Model.Arg","doc":"*   `anyValue` (*type:* `GoogleApi.FirebaseRules.V1.Model.Empty.t`, *default:* `nil`) - Argument matches any value provided.\n*   `exactValue` (*type:* `any()`, *default:* `nil`) - Argument exactly matches value provided.","ref":"GoogleApi.FirebaseRules.V1.Model.Arg.html#module-attributes"},{"type":"function","title":"GoogleApi.FirebaseRules.V1.Model.Arg.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.FirebaseRules.V1.Model.Arg.html#decode/2"},{"type":"type","title":"GoogleApi.FirebaseRules.V1.Model.Arg.t/0","doc":"","ref":"GoogleApi.FirebaseRules.V1.Model.Arg.html#t:t/0"},{"type":"module","title":"GoogleApi.FirebaseRules.V1.Model.Empty","doc":"A generic empty message that you can re-use to avoid defining duplicated empty messages in your APIs. A typical example is to use it as the request or the response type of an API method. For instance: service Foo { rpc Bar(google.protobuf.Empty) returns (google.protobuf.Empty); }","ref":"GoogleApi.FirebaseRules.V1.Model.Empty.html"},{"type":"module","title":"Attributes - GoogleApi.FirebaseRules.V1.Model.Empty","doc":"","ref":"GoogleApi.FirebaseRules.V1.Model.Empty.html#module-attributes"},{"type":"function","title":"GoogleApi.FirebaseRules.V1.Model.Empty.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.FirebaseRules.V1.Model.Empty.html#decode/2"},{"type":"type","title":"GoogleApi.FirebaseRules.V1.Model.Empty.t/0","doc":"","ref":"GoogleApi.FirebaseRules.V1.Model.Empty.html#t:t/0"},{"type":"module","title":"GoogleApi.FirebaseRules.V1.Model.ExpressionReport","doc":"Describes where in a file an expression is found and what it was evaluated to over the course of its use.","ref":"GoogleApi.FirebaseRules.V1.Model.ExpressionReport.html"},{"type":"module","title":"Attributes - GoogleApi.FirebaseRules.V1.Model.ExpressionReport","doc":"*   `children` (*type:* `list(GoogleApi.FirebaseRules.V1.Model.ExpressionReport.t)`, *default:* `nil`) - Subexpressions\n*   `sourcePosition` (*type:* `GoogleApi.FirebaseRules.V1.Model.SourcePosition.t`, *default:* `nil`) - Position of expression in original rules source.\n*   `values` (*type:* `list(GoogleApi.FirebaseRules.V1.Model.ValueCount.t)`, *default:* `nil`) - Values that this expression evaluated to when encountered.","ref":"GoogleApi.FirebaseRules.V1.Model.ExpressionReport.html#module-attributes"},{"type":"function","title":"GoogleApi.FirebaseRules.V1.Model.ExpressionReport.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.FirebaseRules.V1.Model.ExpressionReport.html#decode/2"},{"type":"type","title":"GoogleApi.FirebaseRules.V1.Model.ExpressionReport.t/0","doc":"","ref":"GoogleApi.FirebaseRules.V1.Model.ExpressionReport.html#t:t/0"},{"type":"module","title":"GoogleApi.FirebaseRules.V1.Model.File","doc":"`File` containing source content.","ref":"GoogleApi.FirebaseRules.V1.Model.File.html"},{"type":"module","title":"Attributes - GoogleApi.FirebaseRules.V1.Model.File","doc":"*   `content` (*type:* `String.t`, *default:* `nil`) - Required. Textual Content.\n*   `fingerprint` (*type:* `String.t`, *default:* `nil`) - Fingerprint (e.g. github sha) associated with the `File`.\n*   `name` (*type:* `String.t`, *default:* `nil`) - Required. File name.","ref":"GoogleApi.FirebaseRules.V1.Model.File.html#module-attributes"},{"type":"function","title":"GoogleApi.FirebaseRules.V1.Model.File.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.FirebaseRules.V1.Model.File.html#decode/2"},{"type":"type","title":"GoogleApi.FirebaseRules.V1.Model.File.t/0","doc":"","ref":"GoogleApi.FirebaseRules.V1.Model.File.html#t:t/0"},{"type":"module","title":"GoogleApi.FirebaseRules.V1.Model.FunctionCall","doc":"Represents a service-defined function call that was invoked during test execution.","ref":"GoogleApi.FirebaseRules.V1.Model.FunctionCall.html"},{"type":"module","title":"Attributes - GoogleApi.FirebaseRules.V1.Model.FunctionCall","doc":"*   `args` (*type:* `list(any())`, *default:* `nil`) - The arguments that were provided to the function.\n*   `function` (*type:* `String.t`, *default:* `nil`) - Name of the function invoked.","ref":"GoogleApi.FirebaseRules.V1.Model.FunctionCall.html#module-attributes"},{"type":"function","title":"GoogleApi.FirebaseRules.V1.Model.FunctionCall.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.FirebaseRules.V1.Model.FunctionCall.html#decode/2"},{"type":"type","title":"GoogleApi.FirebaseRules.V1.Model.FunctionCall.t/0","doc":"","ref":"GoogleApi.FirebaseRules.V1.Model.FunctionCall.html#t:t/0"},{"type":"module","title":"GoogleApi.FirebaseRules.V1.Model.FunctionMock","doc":"Mock function definition. Mocks must refer to a function declared by the target service. The type of the function args and result will be inferred at test time. If either the arg or result values are not compatible with function type declaration, the request will be considered invalid. More than one `FunctionMock` may be provided for a given function name so long as the `Arg` matchers are distinct. There may be only one function for a given overload where all `Arg` values are `Arg.any_value`.","ref":"GoogleApi.FirebaseRules.V1.Model.FunctionMock.html"},{"type":"module","title":"Attributes - GoogleApi.FirebaseRules.V1.Model.FunctionMock","doc":"*   `args` (*type:* `list(GoogleApi.FirebaseRules.V1.Model.Arg.t)`, *default:* `nil`) - The list of `Arg` values to match. The order in which the arguments are provided is the order in which they must appear in the function invocation.\n*   `function` (*type:* `String.t`, *default:* `nil`) - The name of the function. The function name must match one provided by a service declaration.\n*   `result` (*type:* `GoogleApi.FirebaseRules.V1.Model.Result.t`, *default:* `nil`) - The mock result of the function call.","ref":"GoogleApi.FirebaseRules.V1.Model.FunctionMock.html#module-attributes"},{"type":"function","title":"GoogleApi.FirebaseRules.V1.Model.FunctionMock.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.FirebaseRules.V1.Model.FunctionMock.html#decode/2"},{"type":"type","title":"GoogleApi.FirebaseRules.V1.Model.FunctionMock.t/0","doc":"","ref":"GoogleApi.FirebaseRules.V1.Model.FunctionMock.html#t:t/0"},{"type":"module","title":"GoogleApi.FirebaseRules.V1.Model.GetReleaseExecutableResponse","doc":"The response for FirebaseRulesService.GetReleaseExecutable","ref":"GoogleApi.FirebaseRules.V1.Model.GetReleaseExecutableResponse.html"},{"type":"module","title":"Attributes - GoogleApi.FirebaseRules.V1.Model.GetReleaseExecutableResponse","doc":"*   `executable` (*type:* `String.t`, *default:* `nil`) - Executable view of the `Ruleset` referenced by the `Release`.\n*   `executableVersion` (*type:* `String.t`, *default:* `nil`) - The Rules runtime version of the executable.\n*   `language` (*type:* `String.t`, *default:* `nil`) - `Language` used to generate the executable bytes.\n*   `rulesetName` (*type:* `String.t`, *default:* `nil`) - `Ruleset` name associated with the `Release` executable.\n*   `syncTime` (*type:* `DateTime.t`, *default:* `nil`) - Optional, indicates the freshness of the result. The response is guaranteed to be the latest within an interval up to the sync_time (inclusive).\n*   `updateTime` (*type:* `DateTime.t`, *default:* `nil`) - Timestamp for the most recent `Release.update_time`.","ref":"GoogleApi.FirebaseRules.V1.Model.GetReleaseExecutableResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.FirebaseRules.V1.Model.GetReleaseExecutableResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.FirebaseRules.V1.Model.GetReleaseExecutableResponse.html#decode/2"},{"type":"type","title":"GoogleApi.FirebaseRules.V1.Model.GetReleaseExecutableResponse.t/0","doc":"","ref":"GoogleApi.FirebaseRules.V1.Model.GetReleaseExecutableResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.FirebaseRules.V1.Model.Issue","doc":"Issues include warnings, errors, and deprecation notices.","ref":"GoogleApi.FirebaseRules.V1.Model.Issue.html"},{"type":"module","title":"Attributes - GoogleApi.FirebaseRules.V1.Model.Issue","doc":"*   `description` (*type:* `String.t`, *default:* `nil`) - Short error description.\n*   `severity` (*type:* `String.t`, *default:* `nil`) - The severity of the issue.\n*   `sourcePosition` (*type:* `GoogleApi.FirebaseRules.V1.Model.SourcePosition.t`, *default:* `nil`) - Position of the issue in the `Source`.","ref":"GoogleApi.FirebaseRules.V1.Model.Issue.html#module-attributes"},{"type":"function","title":"GoogleApi.FirebaseRules.V1.Model.Issue.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.FirebaseRules.V1.Model.Issue.html#decode/2"},{"type":"type","title":"GoogleApi.FirebaseRules.V1.Model.Issue.t/0","doc":"","ref":"GoogleApi.FirebaseRules.V1.Model.Issue.html#t:t/0"},{"type":"module","title":"GoogleApi.FirebaseRules.V1.Model.ListReleasesResponse","doc":"The response for FirebaseRulesService.ListReleases.","ref":"GoogleApi.FirebaseRules.V1.Model.ListReleasesResponse.html"},{"type":"module","title":"Attributes - GoogleApi.FirebaseRules.V1.Model.ListReleasesResponse","doc":"*   `nextPageToken` (*type:* `String.t`, *default:* `nil`) - The pagination token to retrieve the next page of results. If the value is empty, no further results remain.\n*   `releases` (*type:* `list(GoogleApi.FirebaseRules.V1.Model.Release.t)`, *default:* `nil`) - List of `Release` instances.","ref":"GoogleApi.FirebaseRules.V1.Model.ListReleasesResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.FirebaseRules.V1.Model.ListReleasesResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.FirebaseRules.V1.Model.ListReleasesResponse.html#decode/2"},{"type":"type","title":"GoogleApi.FirebaseRules.V1.Model.ListReleasesResponse.t/0","doc":"","ref":"GoogleApi.FirebaseRules.V1.Model.ListReleasesResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.FirebaseRules.V1.Model.ListRulesetsResponse","doc":"The response for FirebaseRulesService.ListRulesets.","ref":"GoogleApi.FirebaseRules.V1.Model.ListRulesetsResponse.html"},{"type":"module","title":"Attributes - GoogleApi.FirebaseRules.V1.Model.ListRulesetsResponse","doc":"*   `nextPageToken` (*type:* `String.t`, *default:* `nil`) - The pagination token to retrieve the next page of results. If the value is empty, no further results remain.\n*   `rulesets` (*type:* `list(GoogleApi.FirebaseRules.V1.Model.Ruleset.t)`, *default:* `nil`) - List of `Ruleset` instances.","ref":"GoogleApi.FirebaseRules.V1.Model.ListRulesetsResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.FirebaseRules.V1.Model.ListRulesetsResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.FirebaseRules.V1.Model.ListRulesetsResponse.html#decode/2"},{"type":"type","title":"GoogleApi.FirebaseRules.V1.Model.ListRulesetsResponse.t/0","doc":"","ref":"GoogleApi.FirebaseRules.V1.Model.ListRulesetsResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.FirebaseRules.V1.Model.Metadata","doc":"Metadata for a Ruleset.","ref":"GoogleApi.FirebaseRules.V1.Model.Metadata.html"},{"type":"module","title":"Attributes - GoogleApi.FirebaseRules.V1.Model.Metadata","doc":"*   `services` (*type:* `list(String.t)`, *default:* `nil`) - Services that this ruleset has declarations for (e.g., \"cloud.firestore\"). There may be 0+ of these.","ref":"GoogleApi.FirebaseRules.V1.Model.Metadata.html#module-attributes"},{"type":"function","title":"GoogleApi.FirebaseRules.V1.Model.Metadata.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.FirebaseRules.V1.Model.Metadata.html#decode/2"},{"type":"type","title":"GoogleApi.FirebaseRules.V1.Model.Metadata.t/0","doc":"","ref":"GoogleApi.FirebaseRules.V1.Model.Metadata.html#t:t/0"},{"type":"module","title":"GoogleApi.FirebaseRules.V1.Model.Release","doc":"`Release` is a named reference to a `Ruleset`. Once a `Release` refers to a `Ruleset`, rules-enabled services will be able to enforce the `Ruleset`.","ref":"GoogleApi.FirebaseRules.V1.Model.Release.html"},{"type":"module","title":"Attributes - GoogleApi.FirebaseRules.V1.Model.Release","doc":"*   `createTime` (*type:* `DateTime.t`, *default:* `nil`) - Output only. Time the release was created.\n*   `name` (*type:* `String.t`, *default:* `nil`) - Required. Format: `projects/{project_id}/releases/{release_id}`\n*   `rulesetName` (*type:* `String.t`, *default:* `nil`) - Required. Name of the `Ruleset` referred to by this `Release`. The `Ruleset` must exist for the `Release` to be created.\n*   `updateTime` (*type:* `DateTime.t`, *default:* `nil`) - Output only. Time the release was updated.","ref":"GoogleApi.FirebaseRules.V1.Model.Release.html#module-attributes"},{"type":"function","title":"GoogleApi.FirebaseRules.V1.Model.Release.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.FirebaseRules.V1.Model.Release.html#decode/2"},{"type":"type","title":"GoogleApi.FirebaseRules.V1.Model.Release.t/0","doc":"","ref":"GoogleApi.FirebaseRules.V1.Model.Release.html#t:t/0"},{"type":"module","title":"GoogleApi.FirebaseRules.V1.Model.Result","doc":"Possible result values from the function mock invocation.","ref":"GoogleApi.FirebaseRules.V1.Model.Result.html"},{"type":"module","title":"Attributes - GoogleApi.FirebaseRules.V1.Model.Result","doc":"*   `undefined` (*type:* `GoogleApi.FirebaseRules.V1.Model.Empty.t`, *default:* `nil`) - The result is undefined, meaning the result could not be computed.\n*   `value` (*type:* `any()`, *default:* `nil`) - The result is an actual value. The type of the value must match that of the type declared by the service.","ref":"GoogleApi.FirebaseRules.V1.Model.Result.html#module-attributes"},{"type":"function","title":"GoogleApi.FirebaseRules.V1.Model.Result.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.FirebaseRules.V1.Model.Result.html#decode/2"},{"type":"type","title":"GoogleApi.FirebaseRules.V1.Model.Result.t/0","doc":"","ref":"GoogleApi.FirebaseRules.V1.Model.Result.html#t:t/0"},{"type":"module","title":"GoogleApi.FirebaseRules.V1.Model.Ruleset","doc":"`Ruleset` is an immutable copy of `Source` with a globally unique identifier and a creation time.","ref":"GoogleApi.FirebaseRules.V1.Model.Ruleset.html"},{"type":"module","title":"Attributes - GoogleApi.FirebaseRules.V1.Model.Ruleset","doc":"*   `attachmentPoint` (*type:* `String.t`, *default:* `nil`) - Immutable. Intended resource to which this Ruleset should be released. May be left blank to signify the resource associated with the default release. Expected format: firestore.googleapis.com/projects//databases/\n*   `createTime` (*type:* `DateTime.t`, *default:* `nil`) - Output only. Time the `Ruleset` was created.\n*   `metadata` (*type:* `GoogleApi.FirebaseRules.V1.Model.Metadata.t`, *default:* `nil`) - Output only. The metadata for this ruleset.\n*   `name` (*type:* `String.t`, *default:* `nil`) - Output only. Name of the `Ruleset`. The ruleset_id is auto generated by the service. Format: `projects/{project_id}/rulesets/{ruleset_id}`\n*   `source` (*type:* `GoogleApi.FirebaseRules.V1.Model.Source.t`, *default:* `nil`) - Required. `Source` for the `Ruleset`.","ref":"GoogleApi.FirebaseRules.V1.Model.Ruleset.html#module-attributes"},{"type":"function","title":"GoogleApi.FirebaseRules.V1.Model.Ruleset.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.FirebaseRules.V1.Model.Ruleset.html#decode/2"},{"type":"type","title":"GoogleApi.FirebaseRules.V1.Model.Ruleset.t/0","doc":"","ref":"GoogleApi.FirebaseRules.V1.Model.Ruleset.html#t:t/0"},{"type":"module","title":"GoogleApi.FirebaseRules.V1.Model.Source","doc":"`Source` is one or more `File` messages comprising a logical set of rules.","ref":"GoogleApi.FirebaseRules.V1.Model.Source.html"},{"type":"module","title":"Attributes - GoogleApi.FirebaseRules.V1.Model.Source","doc":"*   `files` (*type:* `list(GoogleApi.FirebaseRules.V1.Model.File.t)`, *default:* `nil`) - Required. `File` set constituting the `Source` bundle.","ref":"GoogleApi.FirebaseRules.V1.Model.Source.html#module-attributes"},{"type":"function","title":"GoogleApi.FirebaseRules.V1.Model.Source.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.FirebaseRules.V1.Model.Source.html#decode/2"},{"type":"type","title":"GoogleApi.FirebaseRules.V1.Model.Source.t/0","doc":"","ref":"GoogleApi.FirebaseRules.V1.Model.Source.html#t:t/0"},{"type":"module","title":"GoogleApi.FirebaseRules.V1.Model.SourcePosition","doc":"Position in the `Source` content including its line, column number, and an index of the `File` in the `Source` message. Used for debug purposes.","ref":"GoogleApi.FirebaseRules.V1.Model.SourcePosition.html"},{"type":"module","title":"Attributes - GoogleApi.FirebaseRules.V1.Model.SourcePosition","doc":"*   `column` (*type:* `integer()`, *default:* `nil`) - First column on the source line associated with the source fragment.\n*   `currentOffset` (*type:* `integer()`, *default:* `nil`) - Start position relative to the beginning of the file.\n*   `endOffset` (*type:* `integer()`, *default:* `nil`) - End position relative to the beginning of the file.\n*   `fileName` (*type:* `String.t`, *default:* `nil`) - Name of the `File`.\n*   `line` (*type:* `integer()`, *default:* `nil`) - Line number of the source fragment. 1-based.","ref":"GoogleApi.FirebaseRules.V1.Model.SourcePosition.html#module-attributes"},{"type":"function","title":"GoogleApi.FirebaseRules.V1.Model.SourcePosition.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.FirebaseRules.V1.Model.SourcePosition.html#decode/2"},{"type":"type","title":"GoogleApi.FirebaseRules.V1.Model.SourcePosition.t/0","doc":"","ref":"GoogleApi.FirebaseRules.V1.Model.SourcePosition.html#t:t/0"},{"type":"module","title":"GoogleApi.FirebaseRules.V1.Model.TestCase","doc":"`TestCase` messages provide the request context and an expectation as to whether the given context will be allowed or denied. Test cases may specify the `request`, `resource`, and `function_mocks` to mock a function call to a service-provided function. The `request` object represents context present at request-time. The `resource` is the value of the target resource as it appears in persistent storage before the request is executed.","ref":"GoogleApi.FirebaseRules.V1.Model.TestCase.html"},{"type":"module","title":"Attributes - GoogleApi.FirebaseRules.V1.Model.TestCase","doc":"*   `expectation` (*type:* `String.t`, *default:* `nil`) - Test expectation.\n*   `expressionReportLevel` (*type:* `String.t`, *default:* `nil`) - Specifies what should be included in the response.\n*   `functionMocks` (*type:* `list(GoogleApi.FirebaseRules.V1.Model.FunctionMock.t)`, *default:* `nil`) - Optional function mocks for service-defined functions. If not set, any service defined function is expected to return an error, which may or may not influence the test outcome.\n*   `pathEncoding` (*type:* `String.t`, *default:* `nil`) - Specifies whether paths (such as request.path) are encoded and how.\n*   `request` (*type:* `any()`, *default:* `nil`) - Request context. The exact format of the request context is service-dependent. See the appropriate service documentation for information about the supported fields and types on the request. Minimally, all services support the following fields and types: Request field | Type ---------------|----------------- auth.uid | `string` auth.token | `map` headers | `map` method | `string` params | `map` path | `string` time | `google.protobuf.Timestamp` If the request value is not well-formed for the service, the request will be rejected as an invalid argument.\n*   `resource` (*type:* `any()`, *default:* `nil`) - Optional resource value as it appears in persistent storage before the request is fulfilled. The resource type depends on the `request.path` value.","ref":"GoogleApi.FirebaseRules.V1.Model.TestCase.html#module-attributes"},{"type":"function","title":"GoogleApi.FirebaseRules.V1.Model.TestCase.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.FirebaseRules.V1.Model.TestCase.html#decode/2"},{"type":"type","title":"GoogleApi.FirebaseRules.V1.Model.TestCase.t/0","doc":"","ref":"GoogleApi.FirebaseRules.V1.Model.TestCase.html#t:t/0"},{"type":"module","title":"GoogleApi.FirebaseRules.V1.Model.TestResult","doc":"Test result message containing the state of the test as well as a description and source position for test failures.","ref":"GoogleApi.FirebaseRules.V1.Model.TestResult.html"},{"type":"module","title":"Attributes - GoogleApi.FirebaseRules.V1.Model.TestResult","doc":"*   `debugMessages` (*type:* `list(String.t)`, *default:* `nil`) - Debug messages related to test execution issues encountered during evaluation. Debug messages may be related to too many or too few invocations of function mocks or to runtime errors that occur during evaluation. For example: ```Unable to read variable [name: \"resource\"]```\n*   `errorPosition` (*type:* `GoogleApi.FirebaseRules.V1.Model.SourcePosition.t`, *default:* `nil`) - Position in the `Source` or `Ruleset` where the principle runtime error occurs. Evaluation of an expression may result in an error. Rules are deny by default, so a `DENY` expectation when an error is generated is valid. When there is a `DENY` with an error, the `SourcePosition` is returned. E.g. `error_position { line: 19 column: 37 }`\n*   `expressionReports` (*type:* `list(GoogleApi.FirebaseRules.V1.Model.ExpressionReport.t)`, *default:* `nil`) - The mapping from expression in the ruleset AST to the values they were evaluated to. Partially-nested to mirror AST structure. Note that this field is actually tracking expressions and not permission statements in contrast to the \"visited_expressions\" field above. Literal expressions are omitted.\n*   `functionCalls` (*type:* `list(GoogleApi.FirebaseRules.V1.Model.FunctionCall.t)`, *default:* `nil`) - The set of function calls made to service-defined methods. Function calls are included in the order in which they are encountered during evaluation, are provided for both mocked and unmocked functions, and included on the response regardless of the test `state`.\n*   `state` (*type:* `String.t`, *default:* `nil`) - State of the test.\n*   `visitedExpressions` (*type:* `list(GoogleApi.FirebaseRules.V1.Model.VisitedExpression.t)`, *default:* `nil`) - The set of visited permission expressions for a given test. This returns the positions and evaluation results of all visited permission expressions which were relevant to the test case, e.g. ``` match /path { allow read if: } ``` For a detailed report of the intermediate evaluation states, see the `expression_reports` field","ref":"GoogleApi.FirebaseRules.V1.Model.TestResult.html#module-attributes"},{"type":"function","title":"GoogleApi.FirebaseRules.V1.Model.TestResult.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.FirebaseRules.V1.Model.TestResult.html#decode/2"},{"type":"type","title":"GoogleApi.FirebaseRules.V1.Model.TestResult.t/0","doc":"","ref":"GoogleApi.FirebaseRules.V1.Model.TestResult.html#t:t/0"},{"type":"module","title":"GoogleApi.FirebaseRules.V1.Model.TestRulesetRequest","doc":"The request for FirebaseRulesService.TestRuleset.","ref":"GoogleApi.FirebaseRules.V1.Model.TestRulesetRequest.html"},{"type":"module","title":"Attributes - GoogleApi.FirebaseRules.V1.Model.TestRulesetRequest","doc":"*   `source` (*type:* `GoogleApi.FirebaseRules.V1.Model.Source.t`, *default:* `nil`) - Optional. Optional `Source` to be checked for correctness. This field must not be set when the resource name refers to a `Ruleset`.\n*   `testSuite` (*type:* `GoogleApi.FirebaseRules.V1.Model.TestSuite.t`, *default:* `nil`) - Required. The tests to execute against the `Source`. When `Source` is provided inline, the test cases will only be run if the `Source` is syntactically and semantically valid. Inline `TestSuite` to run.","ref":"GoogleApi.FirebaseRules.V1.Model.TestRulesetRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.FirebaseRules.V1.Model.TestRulesetRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.FirebaseRules.V1.Model.TestRulesetRequest.html#decode/2"},{"type":"type","title":"GoogleApi.FirebaseRules.V1.Model.TestRulesetRequest.t/0","doc":"","ref":"GoogleApi.FirebaseRules.V1.Model.TestRulesetRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.FirebaseRules.V1.Model.TestRulesetResponse","doc":"The response for FirebaseRulesService.TestRuleset.","ref":"GoogleApi.FirebaseRules.V1.Model.TestRulesetResponse.html"},{"type":"module","title":"Attributes - GoogleApi.FirebaseRules.V1.Model.TestRulesetResponse","doc":"*   `issues` (*type:* `list(GoogleApi.FirebaseRules.V1.Model.Issue.t)`, *default:* `nil`) - Syntactic and semantic `Source` issues of varying severity. Issues of `ERROR` severity will prevent tests from executing.\n*   `testResults` (*type:* `list(GoogleApi.FirebaseRules.V1.Model.TestResult.t)`, *default:* `nil`) - The set of test results given the test cases in the `TestSuite`. The results will appear in the same order as the test cases appear in the `TestSuite`.","ref":"GoogleApi.FirebaseRules.V1.Model.TestRulesetResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.FirebaseRules.V1.Model.TestRulesetResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.FirebaseRules.V1.Model.TestRulesetResponse.html#decode/2"},{"type":"type","title":"GoogleApi.FirebaseRules.V1.Model.TestRulesetResponse.t/0","doc":"","ref":"GoogleApi.FirebaseRules.V1.Model.TestRulesetResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.FirebaseRules.V1.Model.TestSuite","doc":"`TestSuite` is a collection of `TestCase` instances that validate the logical correctness of a `Ruleset`. The `TestSuite` may be referenced in-line within a `TestRuleset` invocation or as part of a `Release` object as a pre-release check.","ref":"GoogleApi.FirebaseRules.V1.Model.TestSuite.html"},{"type":"module","title":"Attributes - GoogleApi.FirebaseRules.V1.Model.TestSuite","doc":"*   `testCases` (*type:* `list(GoogleApi.FirebaseRules.V1.Model.TestCase.t)`, *default:* `nil`) - Collection of test cases associated with the `TestSuite`.","ref":"GoogleApi.FirebaseRules.V1.Model.TestSuite.html#module-attributes"},{"type":"function","title":"GoogleApi.FirebaseRules.V1.Model.TestSuite.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.FirebaseRules.V1.Model.TestSuite.html#decode/2"},{"type":"type","title":"GoogleApi.FirebaseRules.V1.Model.TestSuite.t/0","doc":"","ref":"GoogleApi.FirebaseRules.V1.Model.TestSuite.html#t:t/0"},{"type":"module","title":"GoogleApi.FirebaseRules.V1.Model.UpdateReleaseRequest","doc":"The request for FirebaseRulesService.UpdateRelease.","ref":"GoogleApi.FirebaseRules.V1.Model.UpdateReleaseRequest.html"},{"type":"module","title":"Attributes - GoogleApi.FirebaseRules.V1.Model.UpdateReleaseRequest","doc":"*   `release` (*type:* `GoogleApi.FirebaseRules.V1.Model.Release.t`, *default:* `nil`) - Required. `Release` to update.\n*   `updateMask` (*type:* `String.t`, *default:* `nil`) - Optional. Specifies which fields to update.","ref":"GoogleApi.FirebaseRules.V1.Model.UpdateReleaseRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.FirebaseRules.V1.Model.UpdateReleaseRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.FirebaseRules.V1.Model.UpdateReleaseRequest.html#decode/2"},{"type":"type","title":"GoogleApi.FirebaseRules.V1.Model.UpdateReleaseRequest.t/0","doc":"","ref":"GoogleApi.FirebaseRules.V1.Model.UpdateReleaseRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.FirebaseRules.V1.Model.ValueCount","doc":"Tuple for how many times an Expression was evaluated to a particular ExpressionValue.","ref":"GoogleApi.FirebaseRules.V1.Model.ValueCount.html"},{"type":"module","title":"Attributes - GoogleApi.FirebaseRules.V1.Model.ValueCount","doc":"*   `count` (*type:* `integer()`, *default:* `nil`) - The amount of times that expression returned.\n*   `value` (*type:* `any()`, *default:* `nil`) - The return value of the expression","ref":"GoogleApi.FirebaseRules.V1.Model.ValueCount.html#module-attributes"},{"type":"function","title":"GoogleApi.FirebaseRules.V1.Model.ValueCount.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.FirebaseRules.V1.Model.ValueCount.html#decode/2"},{"type":"type","title":"GoogleApi.FirebaseRules.V1.Model.ValueCount.t/0","doc":"","ref":"GoogleApi.FirebaseRules.V1.Model.ValueCount.html#t:t/0"},{"type":"module","title":"GoogleApi.FirebaseRules.V1.Model.VisitedExpression","doc":"Store the position and access outcome for an expression visited in rules.","ref":"GoogleApi.FirebaseRules.V1.Model.VisitedExpression.html"},{"type":"module","title":"Attributes - GoogleApi.FirebaseRules.V1.Model.VisitedExpression","doc":"*   `sourcePosition` (*type:* `GoogleApi.FirebaseRules.V1.Model.SourcePosition.t`, *default:* `nil`) - Position in the `Source` or `Ruleset` where an expression was visited.\n*   `value` (*type:* `any()`, *default:* `nil`) - The evaluated value for the visited expression, e.g. true/false","ref":"GoogleApi.FirebaseRules.V1.Model.VisitedExpression.html#module-attributes"},{"type":"function","title":"GoogleApi.FirebaseRules.V1.Model.VisitedExpression.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.FirebaseRules.V1.Model.VisitedExpression.html#decode/2"},{"type":"type","title":"GoogleApi.FirebaseRules.V1.Model.VisitedExpression.t/0","doc":"","ref":"GoogleApi.FirebaseRules.V1.Model.VisitedExpression.html#t:t/0"}],"content_type":"text/markdown","proglang":"elixir","producer":{"name":"ex_doc","version":"0.35.1"}}